## glibc 2.28.19

=== crypt/Makefile ===
# Copyright (C) 1996-2018 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <http://www.gnu.org/licenses/>.

#
#	Sub-makefile for crypt() portion of the library.
#
subdir	:= crypt

include ../Makeconfig

headers := crypt.h

extra-libs := libcrypt
extra-libs-others := $(extra-libs)

libcrypt-routines := crypt-entry md5-crypt sha256-crypt sha512-crypt crypt \
		     crypt_util

tests := cert md5c-test sha256c-test sha512c-test badsalttest

ifeq ($(nss-crypt),yes)
nss-cpp-flags := -DUSE_NSS \
  -I$(shell nss-config --includedir) -I$(shell nspr-config --includedir)
CPPFLAGS-sha256-crypt.c += $(nss-cpp-flags)
CPPFLAGS-sha512-crypt.c += $(nss-cpp-flags)
CPPFLAGS-md5-crypt.c += $(nss-cpp-flags)
LDLIBS-crypt.so = -lfreebl3
else
libcrypt-routines += md5 sha256 sha512

tests += md5test sha256test sha512test

# The test md5test-giant uses up to 400 MB of RSS and runs on a fast
# machine over a minute.
xtests = md5test-giant
endif

include ../Rules

ifneq ($(nss-crypt),yes)
md5-routines := md5 $(filter md5%,$(libcrypt-sysdep_routines))
sha256-routines := sha256 $(filter sha256%,$(libcrypt-sysdep_routines))
sha512-routines := sha512 $(filter sha512%,$(libcrypt-sysdep_routines))

$(objpfx)md5test: $(patsubst %, $(objpfx)%.o,$(md5-routines))
$(objpfx)md5test-giant: $(patsubst %, $(objpfx)%.o,$(md5-routines))
$(objpfx)sha256test: $(patsubst %, $(objpfx)%.o,$(sha256-routines))
$(objpfx)sha512test: $(patsubst %, $(objpfx)%.o,$(sha512-routines))
endif

ifeq (yes,$(build-shared))
$(addprefix $(objpfx),$(tests)): $(objpfx)libcrypt.so
else
$(addprefix $(objpfx),$(tests)): $(objpfx)libcrypt.a
endif

=== sysdeps/alpha/Makefile ===
# Copyright (C) 1993-2018 Free Software Foundation, Inc.
# This file is part of the GNU C Library.
# Contributed by Brendan Kehoe (brendan@zen.org).

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library.  If not, see
# <http://www.gnu.org/licenses/>.

ifeq ($(subdir),db2)
CPPFLAGS += -DHAVE_SPINLOCKS=1 -DHAVE_ASSEM_ALPHA=1
endif

ifeq ($(subdir),debug)
# Consider making this GCC's default...
CFLAGS-backtrace.c = -fasynchronous-unwind-tables
endif

ifeq ($(subdir),gmon)
sysdep_routines += _mcount
endif

ifeq ($(subdir),gnulib)
sysdep_routines += divl divlu divq divqu reml remlu remq remqu
endif

ifeq ($(subdir),string)
sysdep_routines += stxcpy stxncpy
endif

ifeq ($(subdir),elf)
# The ld.so startup code cannot use literals until it self-relocates.
CFLAGS-rtld.c = -mbuild-constants
endif

ifeq ($(subdir),math)
# The fma routines rely on inexact being raised for correct results.
CFLAGS-s_fma.c = -mieee-with-inexact
CFLAGS-s_fmaf.c = -mieee-with-inexact
# This test tries to check for inexact being raised by arithmetic.
CFLAGS-test-misc.c += -mieee-with-inexact
# Avoid "conflicting types for built-in function" warnings
CFLAGS-s_isnan.c += -fno-builtin-isnanf
endif

# Build everything with full IEEE math support, and with dynamic rounding;
# there are a number of math routines that are defined to work with the
# "current" rounding mode, and it's easiest to set this with all of them.
sysdep-CFLAGS += -mieee -mfp-rounding-mode=d

# libc.so requires about 16k for the small data area, which is well
# below the 64k maximum.
pic-ccflag = -fpic

#  Software floating-point emulation.

ifeq ($(subdir),soft-fp)
sysdep_routines += ots_add ots_sub ots_mul ots_div ots_cmp ots_cmpe	\
	ots_cvtxq ots_cvtqx ots_cvtqux ots_cvttx ots_cvtxt ots_nintxq	\
	fraiseexcpt
endif

ifeq ($(subdir),math)
CPPFLAGS += -I../soft-fp
endif

=== debian/changelog ===
glibc (2.28.19-1+dde) unstable; urgency=medium

  * fix CVE-2021-27645

 -- wangyouwan <wangyouwan@uniontech.com>  Thu, 17 Mar 2022 11:48:41 +0800

glibc (2.28.18-1+dde) unstable; urgency=medium

  * add loongarch support

 -- Wang Xiangyu <wangxiangyu@uniontech.com>  Mon, 25 Oct 2021 17:20:26 +0800

glibc (2.28.17-1+dde) oldstable; urgency=medium

  * fix CVE-2021-38604

 -- Clay Stan <liuyong@uniontech.com>  Thu, 09 Sep 2021 14:11:10 +0800

glibc (2.28.16-1+dde) unstable; urgency=medium

  * add patch for CVE-2021-35942
  * 

 -- chenkaixu <chenkaixu@uniontech.com>  Tue, 20 Jul 2021 15:46:44 +0800

glibc (2.28.15-1+dde) unstable; urgency=medium

  * Non-maintainer upload.
  * rebuild to solve compile link on mips.

 -- zhouzilong <zhouzilong@uniontech.com>  Wed, 28 Apr 2021 17:10:26 +0800

glibc (2.28.14-1+dde) unstable; urgency=medium

  * rebuild.
  * fix: https://pms.uniontech.com/zentao/bug-view-66561.html

 -- Hu Feng <hufeng@uniontech.com>  Tue, 06 Apr 2021 09:17:26 +0800

glibc (2.28.13-1+dde) unstable; urgency=medium

  * x86 Add Hygon Dhyana support.
  *
  * This patch fix Hygon Dhyana processor CPU Vendor ID detection
    problem in glibc sysdep module, current glibc codes doesn't
    recognize Dhyana CPU Vendor ID("HygonGenuine") and set kind to
    arch_kind_other, which result to incorrect zero value for
    __cache_sysconf() syscall. As Hygon Dhyana share most
    architecture feature as AMD Family 17h, this patch add Hygon CPU
    Vendor ID check and setup kind to arch_kind_amd and reuse AMD
    code path, which lead to correct return value in
    __cache_sysconf() syscall. we run the glibc test suite for both
    Hygon Dhyana and AMD EPYC and found no failure case.

 -- caitongxun <caitongxununiontech.com>  Wed, 10 Mar 2021 16:57:16 +0800

glibc (2.28.12-1+eagle) unstable; urgency=medium

  * fix CVE-2021-3326 

 -- zhouzilong <zhouzilong@uniontech.com>  Fri, 26 Feb 2021 11:01:32 +0800

glibc (2.28.11-1+eagle) unstable; urgency=medium

  * Version release.
  * Fix CVE-2020-27618, CVE-2019-25013

 -- zhouzilong <zhouzilong@uniontech.com>  Mon, 08 Feb 2021 10:10:57 +0800

glibc (2.28.10-1+dde) unstable; urgency=medium

  * add nop before syscall for promote branch prediction.
  * Subject: [PATCH 1/2] glibc-2.20: Used-madd.d-in-fma-function

 -- Hu Feng <hufeng@uniontech.com>  Thu, 24 Sep 2020 20:30:44 +0800

glibc (2.28.9-1+dde) unstable; urgency=medium

  * Non-maintainer upload.
  * rebuild

 -- guozhijun <guozhijun@uniontech.com>  Thu, 20 Aug 2020 13:30:52 +0800

glibc (2.28.8.1-1+dde) unstable; urgency=medium

  * Non-maintainer upload.
  * rebuild

 -- zhouzilong <zhouzilong@uniontech.com>  Thu, 09 Jul 2020 18:30:56 +0800

glibc (2.28-12+deepin) unstable; urgency=medium

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fix infinite loop in pldd.  Closes: #913929.

 -- Aurelien Jarno <aurel32@debian.org>  Wed, 01 May 2019 19:24:19 +0200

=== debian/control ===
Source: glibc
Section: libs
Priority: required
Build-Depends: gettext, dpkg (>= 1.18.7), dpkg-dev (>= 1.17.14), xz-utils, file, quilt,
 autoconf, gawk, debhelper (>= 10), rdfind, symlinks, netbase, gperf, bison,
 linux-libc-dev (>= 3.9) [linux-any],
 libaudit-dev [linux-any], libcap-dev [linux-any], libselinux-dev [linux-any],
 mig (>= 1.5-3) [hurd-i386], gnumach-dev (>= 2:1.8+git20181103-1~) [hurd-i386],
 hurd-dev (>= 1:0.9.git20181030-1) [hurd-i386] | hurd-headers-dev [hurd-i386],
 hurd-dev (>= 1:0.9.git20181030-1) [hurd-i386] <!stage1> | libihash-dev [hurd-i386] <!stage1>,
 kfreebsd-kernel-headers [kfreebsd-any],
 binutils (>= 2.29),
 g++-8, g++-8-multilib [amd64 i386 kfreebsd-amd64 mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el powerpc ppc64 s390x sparc sparc64 x32] <!nobiarch>,
 python3:native <!nocheck>,
 libidn2-0 (>= 2.0.5~) <!nocheck>,
 libc-bin (>= 2.28.15) <cross>
Build-Depends-Indep: perl, po-debconf (>= 1.0)
Maintainer: GNU Libc Maintainers <debian-glibc@lists.debian.org>
Uploaders: Clint Adams <clint@debian.org>, Aurelien Jarno <aurel32@debian.org>, Adam Conrad <adconrad@0c3.net>, Samuel Thibault <sthibault@debian.org>
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/glibc-team/glibc
Vcs-Git: https://salsa.debian.org/glibc-team/glibc.git
Homepage: https://www.gnu.org/software/libc/libc.html

Package: libc-bin
Architecture: any
Section: libs
Priority: required
Essential: yes
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: manpages
Build-Profiles: <!stage1>
Description: GNU C Library: Binaries
 This package contains utility programs related to the GNU C Library.
 .
  * catchsegv: catch segmentation faults in programs
  * getconf: query system configuration variables
  * getent: get entries from administrative databases
  * iconv, iconvconfig: convert between character encodings
  * ldd, ldconfig: print/configure shared library dependencies
  * locale, localedef: show/generate locale definitions
  * tzselect, zdump, zic: select/dump/compile time zones

Package: libc-dev-bin
Architecture: any
Section: libdevel
Priority: optional
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: manpages, manpages-dev
Build-Profiles: <!stage1>
Description: GNU C Library: Development binaries
 This package contains utility programs related to the GNU C Library
 development package.

Package: libc-l10n
Architecture: all
Section: localization
Priority: standard
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: locales (<< 2.21-1)
Replaces: locales (<< 2.21-1)
Build-Profiles: <!stage1>
Description: GNU C Library: localization files
 This package contains the translation files for the GNU C library and
 utility programs.

Package: glibc-doc
Architecture: all
Section: doc
Priority: optional
Multi-Arch: foreign
Depends: ${misc:Depends}
Suggests: glibc-doc-reference
Build-Profiles: <!stage1>
Description: GNU C Library: Documentation
 Contains man pages for libpthread functions and the complete GNU C Library
 ChangeLog.  The GNU C Library Reference manual has been moved into
 glibc-doc-reference for licensing reasons.

Package: glibc-source
Architecture: all
Section: devel
Priority: optional
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: xz-utils
Breaks: cross-toolchain-base (<< 29~), cross-toolchain-base-ports (<< 25~)
Conflicts: eglibc-source
Replaces: eglibc-source
Build-Profiles: <!stage1>
Description: GNU C Library: sources
 This package contains the sources and patches which are needed to
 build glibc.

Package: locales
Architecture: all
Section: localization
Priority: standard
Depends: libc-bin (>> 2.28.15), libc-l10n (>> 2.28.15), ${misc:Depends}, debconf | debconf-2.0
Replaces: manpages-fr-extra (<< 20141022)
Build-Profiles: <!stage1>
Description: GNU C Library: National Language (locale) data [support]
 Machine-readable data files, shared objects and programs used by the
 C library for localization (l10n) and internationalization (i18n) support.
 .
 This package contains tools to generate locale definitions from source
 files (included in this package). It allows you to customize which
 definitions actually get generated. This is a space-saver over how this
 package used to be, with all locales generated by default. This created
 a package that unpacked to an excess of 30 megs.

Package: locales-all
Architecture: any
Section: localization
Priority: optional
Multi-Arch: foreign
Depends: libc-l10n (>> 2.28.15), ${misc:Depends}
Breaks: locales (<< 2.13-17)
Build-Profiles: <!stage1>
Description: GNU C Library: Precompiled locale data
 This package contains the precompiled locale data for all supported locales.
 A better alternative is to install the locales package and only select
 desired locales, but it can be useful on a low-memory machine because some
 locale files take a lot of memory to be compiled.

Package: nscd
Architecture: any
Section: admin
Multi-Arch: foreign
Priority: optional
Depends: lsb-base (>= 3.0-6), ${shlibs:Depends}, ${misc:Depends}
Build-Profiles: <!stage1>
Description: GNU C Library: Name Service Cache Daemon
 A daemon which handles passwd, group and host lookups
 for running programs and caches the results for the next
 query. You should install this package only if you use
 slow services like LDAP, NIS or NIS+.

Package: multiarch-support
Architecture: any
Section: oldlibs
Multi-Arch: foreign
Depends: ${misc:Depends},
         libc6 (>= 2.3.6-2) [!any-i386 !alpha !armhf !hurd-any !ia64 !kfreebsd-any],
         libc6.1 (>= 2.3.6-2) [alpha ia64],
         libc0.3 (>= 2.3.6-2) [!linux-any !kfreebsd-any !hurd-i386],
         libc0.1 (>= 2.3.6-2) [!linux-any !hurd-any !kfreebsd-i386],
         libc6 (>= 2.13-5) [armhf i386],
         libc0.3 (>= 2.13-5) [hurd-i386],
         libc0.1 (>= 2.13-5) [kfreebsd-i386],
Priority: optional
Build-Profiles: <!stage1>
Description: Transitional package to ensure multiarch compatibility
 This is a transitional package used to ensure multiarch support is present
 in ld.so before unpacking libraries to the multiarch directories.  It can
 be removed once nothing on the system depends on it.

Package: libc6
Architecture: amd64 arm64 armel armhf hppa i386 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el nios2 powerpc powerpcspe ppc64 ppc64el riscv64 sparc sparc64 s390x sh3 sh4 x32 loongarch64
Section: libs
Priority: optional
Multi-Arch: same
Depends: ${shlibs:Depends}, ${libgcc:Depends}
Recommends: libidn2-0 (>= 2.0.5~)
Suggests: glibc-doc, debconf | debconf-2.0, libc-l10n, locales [!hurd-i386]
Provides: libc6-sparcv9b [sparc sparc64], libc0.1-i686 [kfreebsd-i386], libc0.3-i686 [hurd-i386], libc6-i686 [i386]
Conflicts: libc6-loongson2f [mipsel], libc0.1-i686 [kfreebsd-i386], libc6-i686 [i386], openrc (<< 0.27-2~)
Breaks: nscd (<< 2.28.15), locales (<< 2.28.15), locales-all (<< 2.28.15), hurd (<< 1:0.5.git20140203-1), libtirpc1 (<< 0.2.3), r-cran-later (<< 0.7.5+dfsg-2), nocache (<< 1.1-1~)
Replaces: libc6-amd64 [amd64],
          libc6-i386 [i386],
          libc0.1-i686 [kfreebsd-i386],
          libc0.3-i686 [hurd-i386],
          libc6-i686 [i386],
          libc6-x32 [x32],
          libc0.1-i386 [kfreebsd-i386],
          libc6-powerpc [powerpc],
          libc6-ppc64 [ppc64],
          libc6-s390x [s390x],
          libc6-sparc64 [sparc64],
          libc6-mips64 [mips64 mips64el],
          libc6-mipsn32 [mipsn32 mipsn32el],
          libc6-mips32 [mips mipsel],
          hurd (<< 20120408-3) [hurd-i386]
Build-Profiles: <!stage1>
Description: GNU C Library: Shared libraries
 Contains the standard libraries that are used by nearly all programs on
 the system. This package includes shared versions of the standard C library
 and the standard math library, as well as many others.

Package: libc6-dev
Architecture: amd64 arm64 armel armhf hppa i386 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el nios2 powerpc powerpcspe ppc64 ppc64el riscv64 sparc sparc64 s390x sh3 sh4 x32 loongarch64
Section: libdevel
Priority: optional
Multi-Arch: same
Depends: libc6 (= ${binary:Version}) <!stage1>, libc-dev-bin (= ${binary:Version}), ${misc:Depends}, linux-libc-dev [linux-any], kfreebsd-kernel-headers (>= 0.11) [kfreebsd-any], gnumach-dev [hurd-i386], hurd-dev (>= 20080607-3) [hurd-i386] | hurd-headers-dev [hurd-i386]
Replaces: hurd-dev (<< 20120408-3) [hurd-i386], kfreebsd-kernel-headers (<< 10.3~4) [kfreebsd-amd64 kfreebsd-i386]
Suggests: glibc-doc, manpages-dev
Provides: libc-dev, libc6-dev [alpha ia64 hurd-i386 kfreebsd-i386 kfreebsd-amd64]
Breaks: binutils (<< 2.26), binutils-gold (<< 2.20.1-11), cmake (<< 2.8.4+dfsg.1-5), gcc-4.4 (<< 4.4.6-4), gcc-4.5 (<< 4.5.3-2), gcc-4.6 (<< 4.6.0-12), make (<< 3.81-8.1), pkg-config (<< 0.26-1), libjna-java (<< 3.2.7-4), liblouis-dev (<< 2.3.0-2), liblouisxml-dev (<< 2.4.0-2), libhwloc-dev (<< 1.2-3), check (<< 0.9.10-6.1+b1) [s390x], kfreebsd-kernel-headers (<< 10.3~4) [kfreebsd-amd64 kfreebsd-i386], libperl5.26 (<< 5.26.1-3)
Conflicts: libc6.1-dev, libc0.1-dev, libc0.3-dev,
Description: GNU C Library: Development Libraries and Header Files
 Contains the symlinks, headers, and object files needed to compile
 and link programs which use the standard C library.

Package: libc6-dbg
Architecture: amd64 arm64 armel armhf hppa i386 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el nios2 powerpc powerpcspe ppc64 ppc64el riscv64 sparc sparc64 s390x sh3 sh4 x32 loongarch64
Section: debug
Priority: optional
Multi-Arch: same
Provides: libc-dbg
Depends: libc6 (= ${binary:Version}), ${misc:Depends}
Build-Profiles: <!stage1>
Description: GNU C Library: detached debugging symbols
 This package contains the detached debugging symbols for the GNU C
 library.

Package: libc6-pic
Architecture: amd64 arm64 armel armhf hppa i386 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el nios2 powerpc powerpcspe ppc64 ppc64el riscv64 sparc sparc64 s390x sh3 sh4 x32 loongarch64
Section: libdevel
Priority: optional
Multi-Arch: same
Conflicts: libc-pic
Provides: libc-pic, glibc-pic
Depends: libc6 (= ${binary:Version}), ${misc:Depends}
Build-Profiles: <!stage1>
Description: GNU C Library: PIC archive library
 Contains an archive library (ar file) composed of individual shared objects.
 This is used for creating a library which is a smaller subset of the
 standard libc shared library. The reduced library is used by debian-installer
 and may be useful for custom installation media and in embedded systems.

Package: libc6-udeb
Package-Type: udeb
Architecture: amd64 arm64 armel armhf hppa i386 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el nios2 powerpc powerpcspe ppc64 ppc64el riscv64 sparc sparc64 s390x sh3 sh4 x32 loongarch64
Section: debian-installer
Priority: optional
Provides: libc6, libc-udeb, libnss-dns-udeb, libnss-files-udeb, ${locale-compat:Depends}
Build-Profiles: <!stage1>
Description: GNU C Library: Shared libraries - udeb
 Contains the standard libraries that are used by nearly all programs on
 the system. This package includes shared versions of the standard C library
 and the standard math library, as well as many others.
 .
 This package contains a minimal set of libraries needed for the Debian
 installer.  Do not install it on a normal system.

Package: libc6.1
Architecture: alpha ia64
Section: libs
Priority: optional
Multi-Arch: same
Depends: ${shlibs:Depends}, ${libgcc:Depends}
Recommends: libidn2-0 (>= 2.0.5~)
Suggests: glibc-doc, debconf | debconf-2.0, libc-l10n, locales [!hurd-i386]
Provides: libc6-sparcv9b [sparc sparc64], libc0.1-i686 [kfreebsd-i386], libc0.3-i686 [hurd-i386], libc6-i686 [i386]

## glibc 2.28.21

=== nptl_db/Makefile ===
# Copyright (C) 2002-2018 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <http://www.gnu.org/licenses/>.

# Makefile for NPTL debug library subdirectory of GNU C Library.

subdir          := nptl_db

include ../Makeconfig

nptl_db-version = 1.0

extra-libs = libthread_db
extra-libs-others := $(extra-libs)

headers         = proc_service.h thread_db.h sys/procfs.h

libthread_db-routines = td_init td_log td_ta_new td_ta_delete \
			td_ta_get_nthreads td_ta_get_ph \
			td_ta_map_id2thr td_ta_map_lwp2thr \
			td_ta_thr_iter td_ta_tsd_iter \
			td_thr_get_info td_thr_getfpregs td_thr_getgregs \
			td_thr_getxregs td_thr_getxregsize td_thr_setfpregs \
			td_thr_setgregs td_thr_setprio td_thr_setsigpending \
			td_thr_setxregs td_thr_sigsetmask td_thr_tsd \
			td_thr_validate td_thr_dbsuspend td_thr_dbresume \
			td_ta_setconcurrency td_ta_enable_stats \
			td_ta_reset_stats td_ta_get_stats td_ta_event_addr \
			td_thr_event_enable td_thr_set_event \
			td_thr_clear_event td_thr_event_getmsg \
			td_ta_set_event td_ta_event_getmsg \
			td_ta_clear_event td_symbol_list \
			td_thr_tlsbase td_thr_tls_get_addr \
			fetch-value

libthread_db-inhibit-o = $(filter-out .os,$(object-suffixes))

# The ps_* callback functions are not defined.
libthread_db.so-no-z-defs = yes

tests-special += $(objpfx)db-symbols.out

include ../Rules

$(objpfx)db-symbols.out: $(objpfx)db-symbols.v.i \
			 $(common-objpfx)nptl/libpthread.so
	LC_ALL=C $(READELF) -W -s $(filter %.so,$^) | $(AWK) -f $< > $@; \
	$(evaluate-test)

$(objpfx)db-symbols.v.i: db-symbols.awk

=== sysdeps/powerpc/powerpc32/power4/multiarch/Makefile ===
ifeq ($(subdir),string)
sysdep_routines += memcpy-power7 memcpy-a2 memcpy-power6 memcpy-cell \
		   memcpy-ppc32 memcmp-power7 memcmp-ppc32 memset-power7 \
		   memset-power6 memset-ppc32 bzero-power7 bzero-power6 \
		   bzero-ppc32 mempcpy-power7 mempcpy-ppc32 memchr-power7 \
		   memchr-ppc32 memrchr-power7 memrchr-ppc32 rawmemchr-power7 \
		   rawmemchr-ppc32 strlen-power7 strlen-ppc32 strnlen-power7 \
		   strnlen-ppc32 strncmp-power7 strncmp-ppc32 \
		   strcasecmp-power7 strcasecmp_l-power7 strncase-power7 \
		   strncase_l-power7 strchrnul-power7 strchrnul-ppc32 \
		   strchr-power7 strchr-ppc32 \
		   wordcopy-power7 wordcopy-ppc32 \
		   memmove-power7 memmove-ppc

CFLAGS-strncase-power7.c += -mcpu=power7 -funroll-loops
CFLAGS-strncase_l-power7.c += -mcpu=power7 -funroll-loops
endif

ifeq ($(subdir),wcsmbs)
sysdep_routines += wcschr-power7 wcschr-power6 wcschr-ppc32 \
		   wcsrchr-power7 wcsrchr-power6 wcsrchr-ppc32 \
		   wcscpy-power7 wcscpy-power6 wcscpy-ppc32

CFLAGS-wcschr-power7.c += -mcpu=power7
CFLAGS-wcschr-power6.c += -mcpu=power6
CFLAGS-wcsrchr-power7.c += -mcpu=power7
CFLAGS-wcsrchr-power6.c += -mcpu=power6
CFLAGS-wcscpy-power7.c += -mcpu=power7
CFLAGS-wcscpy-power6.c += -mcpu=power6
endif

## glibc 2.28.21-1+deepin

=== debian/changelog ===
glibc (2.28.21-1+deepin-1) unstable; urgency=medium

  * fix 5 cve issues
    CVE-2021-33574
    CVE-2021-3999
    CVE-2022-23218
    CVE-2022-23219
    CVE-2020-6096

 -- Ding Heng <dingheng@uniontech.com>  Fri, 21 Oct 2022 16:25:55 +0800

glibc (2.28.20-1+dde) unstable; urgency=medium

  * fix SEM_STAT_ANY-kernel-argument-pass

 -- maqi <maqi@uniontech.com>  Mon, 08 Aug 2022 13:35:10 +0800

=== debian/rules ===
#! /usr/bin/make -f
# -*- makefile -*-
# debian/rules file for GNU libc.
# Copyright 1998, 1999 by Joel Klecker <espy@debian.org>
# Copyright 2000 Ben Collins <bcollins@debian.org>
# Copyright 2003 Jeff Bailey <jbailey@debian.org>
# This Makefile is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# What are the phases to building glibc?

# Unpack main tarball
# Do any necessary overlays
# Apply patches
# Determine how many builds there are to do.  For Each build:

#  Create build directory
#  Configure
#  Build
#  Test as desired
#  Install to package directories

# Run debian magic to build packages.

# Things you may need to customise:

# These are done as absolute paths so that in the case of filesystem size
# limitations, they can be overridden and spread all over.
build-tree := build-tree
stamp := $(CURDIR)/stamp-dir/
DUMMY := $(shell mkdir -p $(stamp))

# Beyond here you shouldn't need to customise anything:
export SHELL          = /bin/bash -e
DEB_BUILD_OPTIONS+=nocheck

DEB_HOST_ARCH         ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_ENDIAN  ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_ENDIAN)
DEB_HOST_ARCH_OS      ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_GNU_TYPE     ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_HOST_MULTIARCH    ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_BUILD_ARCH        ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
DEB_BUILD_ARCH_BITS   ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH_BITS)
DEB_BUILD_GNU_TYPE    ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

DEB_SOURCE_PACKAGE := $(strip $(shell egrep '^Source: ' debian/control | cut -f 2 -d ':'))

DEB_VERSION := $(shell dpkg-parsechangelog | egrep '^Version:' | cut -f 2 -d ' ')
GLIBC_VERSION = $(shell echo $(DEB_VERSION) | sed -e 's/.*://' -e 's/[+-].*//')

SOURCE_DATE_EPOCH ?= $(shell dpkg-parsechangelog -STimestamp)

# The minimum package version with which these packages are compatible.
shlib_dep_ver = $(GLIBC_VERSION)
shlib_dep = $(libc) (>= $(shlib_dep_ver))

DEB_BUILDDIR ?= $(build-tree)/$(DEB_HOST_ARCH)-$(curpass)
DEB_BUILDDIRLIBC ?= $(build-tree)/$(DEB_HOST_ARCH)-libc

GLIBC_SOURCES = $(filter-out debian $(shell basename $(stamp)) $(build-tree), $(wildcard *))
		 
# Support multiple makes at once based on number of processors
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
NJOBS := -j $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

# use the package settings, not the settings from the environment
define unsetenv
  unexport $(1)
  $(1) =
endef
$(foreach v, CPPFLAGS CFLAGS CXXFLAGS LDFLAGS, $(if $(filter environment,$(origin $(v))),$(eval $(call unsetenv, $(v)))))

# Default setup
GLIBC_PASSES ?= libc

prefix=/usr
bindir=$(prefix)/bin
datadir=$(prefix)/share
complocaledir=$(prefix)/lib/locale
sysconfdir=/etc
libexecdir=$(prefix)/lib
rootsbindir=/sbin
includedir=$(prefix)/include
docdir=$(prefix)/share/doc
mandir=$(prefix)/share/man
sbindir=$(prefix)/sbin
vardbdir=/var/lib/misc
rtlddir=/lib
slibdir=/lib/$(DEB_HOST_MULTIARCH)
libdir=/usr/lib/$(DEB_HOST_MULTIARCH)
mvec = no


BASE_CC = gcc
BASE_CXX = g++
BASE_MIG = mig
DEB_GCC_VERSION ?= -8

RUN_TESTSUITE = yes
TIMEOUTFACTOR = 25

# Set cross and native compiler names, including version.
CC     = $(DEB_HOST_GNU_TYPE)-$(BASE_CC)$(DEB_GCC_VERSION) -no-pie -fno-PIE
CXX    = $(DEB_HOST_GNU_TYPE)-$(BASE_CXX)$(DEB_GCC_VERSION) -no-pie -fno-PIE
MIG    = $(DEB_HOST_GNU_TYPE)-$(BASE_MIG)
BUILD_CC = $(DEB_BUILD_GNU_TYPE)-$(BASE_CC)
BUILD_CXX = $(DEB_BUILD_GNU_TYPE)-$(BASE_CXX)

BUILD_CFLAGS = -O2 -g
HOST_CFLAGS = -pipe -O2 -g $(call xx,extra_cflags)

# 32-bit MIPS builders have a 2GB memory space. This is not enough to
# build test-tgmath3.o with GCC, unless tweaking the garbage collector.
ifeq ($(findstring mips,$(DEB_BUILD_ARCH))-$(DEB_BUILD_ARCH_BITS), mips-32)
  CC += --param ggc-min-expand=10
endif

configure_target := $(DEB_HOST_GNU_TYPE)

# Normally we'll just use this for --build.  If the architecture requires
# that build daemons be able to run a particular optimized library, then
# they can set the --build to match --host for that optimized build.
# Among other things this lets tests run.
configure_build := $(DEB_BUILD_GNU_TYPE)

# Which build pass are we on?
curpass = $(filter-out %_,$(subst _,_ ,$@))

ifneq ($(filter stage1,$(DEB_BUILD_PROFILES)),)
  DEB_ARCH_REGULAR_PACKAGES = $(libc)-dev
  DEB_INDEP_REGULAR_PACKAGES = 
  DEB_UDEB_PACKAGES = 
  ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
    DEB_BUILD_OPTIONS+=nocheck
  endif
else
  DEB_ARCH_REGULAR_PACKAGES = $(libc) $(libc)-dev $(libc)-dbg $(libc)-pic libc-bin libc-dev-bin multiarch-support
  DEB_INDEP_REGULAR_PACKAGES = glibc-doc glibc-source libc-l10n locales
  DEB_UDEB_PACKAGES = $(libc)-udeb
  ## Locales can only be pre-generated during native compiles
  ifeq ($(DEB_HOST_ARCH),$(DEB_BUILD_ARCH))
    DEB_ARCH_REGULAR_PACKAGES += locales-all
  endif
endif

# Generic kernel version check
define kernel_check
(if [ $(CURRENT_KERNEL_VERSION) -lt $(1) ]; then \
  false; \
fi)
endef

# Include libidn for both NPTL and FBTL targets.
standard-add-ons = libidn,

# Pull in all the per-arch magic!

-include debian/sysdeps/$(DEB_HOST_ARCH_OS).mk
-include debian/sysdeps/$(DEB_HOST_ARCH).mk

ifneq ($(filter stage1,$(DEB_BUILD_PROFILES)),)
DEB_ARCH_REGULAR_PACKAGES += $(foreach p,$(DEB_ARCH_MULTILIB_PACKAGES), $(if $(findstring -dev,$(p)), $(p)))
else
DEB_ARCH_REGULAR_PACKAGES += $(DEB_ARCH_MULTILIB_PACKAGES)
endif

# Don't run dh_strip on this package
NOSTRIP_$(libc)-dbg = 1

# Put the debug files from these packages in $(libc)-dbg
DEBUG_$(libc) = 1
DEBUG_libc6-xen = 1
DEBUG_libc6.1-alphaev67 = 1

ifneq ($(DEB_HOST_ARCH),loongarch64)
ifeq ($(filter stage1,$(DEB_BUILD_PROFILES)),)
  ifeq ($(threads),yes)
  DEB_ARCH_REGULAR_PACKAGES += nscd
  endif
endif
endif

# And now the rules...
include debian/rules.d/*.mk

clean:: unpatch
	rm -rf $(patsubst %,debian/tmp-%,$(GLIBC_PASSES))
	rm -rf $(build-tree)
	rm -rf $(stamp)
	rm -rf debian/include
	rm -f debian/control.in/libc0.1 debian/control.in/libc0.3 \
		debian/control.in/libc6 debian/control.in/libc6.1 \
		debian/*.preinst.*

# Required Debian targets
build-arch: $(stamp)info \
	$(patsubst %,$(stamp)build_%,$(GLIBC_PASSES)) \
	$(patsubst %,$(stamp)check_%,$(GLIBC_PASSES))
ifeq ($(filter stage1,$(DEB_BUILD_PROFILES)),)
build-arch: $(stamp)build_C.UTF-8 \
	$(stamp)build_locales-all
endif

build-indep: $(stamp)source

build: build-arch build-indep


binary-indep: build-indep testroot debian/control $(build-tree) \
	$(patsubst %,$(stamp)binaryinst_%,$(DEB_INDEP_REGULAR_PACKAGES))

binary-arch: build-arch testroot debian/control $(build-tree) \
	$(patsubst %,$(stamp)binaryinst_%,$(DEB_ARCH_REGULAR_PACKAGES)) \
	$(patsubst %,$(stamp)binaryinst_%,$(DEB_UDEB_PACKAGES))

binary: binary-indep binary-arch

testroot:
	dh_testroot

## glibc 2.29

=== debian/changelog ===
glibc (2.29-1+rpi1) bullseye-staging; urgency=medium

  [changes brought forward from 2.25-2+rpi1 by Peter Michael Green <plugwash@raspbian.org> at Wed, 29 Nov 2017 03:00:21 +0000]
  * Disable testsuite.

 -- Raspbian forward porter <root@raspbian.org>  Tue, 17 Sep 2019 01:28:57 +0000

glibc (2.29-1) unstable; urgency=medium

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fix math tests on alpha.
  * debian/sysdeps/alpha.mk, debian/control.in/main: do not force build with
    gcc-8.
  * debian/testsuite-xfail-debian.mk: XFAIL narrowing add/sub tests, they
    have always failed since they have been introduced.
  * debian/control.in/libc: add a Breaks: iraf-fitsutil (<< 2018.07.06-4) to
    libc0.1/0.3/6/6.1. See bug#939523.
  * debian/testsuite-xfail-debian.mk: drop XFAILs related to the wrong value
    of (MIN)SIGSTKSZ for 32-bit processes on arm64, now that (old-)stable
    kernels are fixed.

  [ Samuel Thibault ]
  * debian/patches/hurd-i386/submitted-anon-mmap-shared.diff: Enable, now that
    hurd 2017 is behind.
  * control: Break old version of hurd package accordingly.
  * debian/patches/hurd-i386/local-exec_filename.diff: Fix glibc 2.26
    _hurd_exec_paths symbol visibility.

 -- Aurelien Jarno <aurel32@debian.org>  Sun, 08 Sep 2019 22:34:02 +0200

glibc (2.29-0experimental1) experimental; urgency=medium

  [ Aurelien Jarno ]
  * debian/patches/hurd-i386/submitted-net.diff: rebase.
  * debian/patches/hurd-i386/local-fix-nss.diff: rebase.
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fix math tests on hppa.
  * debian/testsuite-xfail-debian.mk: XFAIL two new tests on HPPA that are
    due to a bug in the testsuite, reported upstream.
  * debian/sysdeps/sparc64.mk: disable PIE on sparc64 as it produces broken
    binaries, causing issues in the testsuite.
  * debian/sysdeps/alpha.mk, debian/control.in/main: build with gcc-8 on alpha
    as gcc-9 introduces math errors in the testsuite.

 -- Aurelien Jarno <aurel32@debian.org>  Wed, 21 Aug 2019 11:13:51 +0200

glibc (2.29-0experimental0) experimental; urgency=medium

  [ Adam Conrad ]
  * New upstream release 2.29, with git updates up to 2019-02-20:
    - Add PF_XDP, AF_XDP and SOL_XDP to bits/socket.h.  Closes: #933800.
    - debian/symbols.wildcard: Add 2.29, and debian/control: Regenrate.
    - debian/patches/localedata/locales_CH.diff: Applied upstream.
    - debian/patches/localedata/submitted-it_IT-thousands_sep.diff: Upstreamed.
    - debian/patches/localedata/git-en_US-date_fmt.diff: Applied upstream.
    - debian/patches/hurd-i386/git-magic-pid.diff: Applied upstream.
    - debian/patches/hurd-i386/git-interrupt_timeout_EIO.diff: Upstreamed.
    - debian/patches/hurd-i386/git-interrupt_timeout.diff: Applied upstream.
    - debian/patches/hurd-i386/git-intr-msg.diff: Applied upstream.
    - debian/patches/hurd-i386/git-pci.diff: Applied upstream.
    - debian/patches/hurd-i386/git-msync.diff: Applied upstream.
    - debian/patches/hurd-i386/git-spawn-open.diff: Applied upstream.
    - debian/patches/hurd-i386/git-tst-preadvwritev2-common.c.diff: Upstreamed.
    - debian/patches/hurd-i386/git-fcntl64.diff: Applied upstream.
    - debian/patches/hurd-i386/git-lockf-0.diff: Applied upstream.
    - debian/patches/hurd-i386/git-libpthread_setpshared.diff: Upstreamed.
    - debian/patches/hurd-i386/git-AT_EMPTY_PATH.diff: Applied upstream.
    - debian/patches/hurd-i386/git-altstack.diff: Applied upstream.
    - debian/patches/riscv64/git-thread-debugging.diff: Applied upstream.
    - debian/patches/sparc/submitted-sparc64-socketcall.diff: Applied upstream.
    - debian/patches/any/local-tst-mktime2.diff: Applied upstream.
    - debian/patches/all/local-remove-manual.diff: Rebased.
    - debian/patches/alpha/local-string-functions.diff: Rebased.
    - debian/patches/any/git-libio-stdout-putc.diff: Rebased.
    - debian/patches/hurd-i386/local-exec_filename.diff: Rebased.
    - debian/patches/hurd-i386/local-hurdsig-globaldisp-version.diff: Rebased.
    - debian/patches/hurd-i386/submitted-anon-mmap-shared.diff: Rebased.
    - debian/patches/hurd-i386/tg-EGREGIOUS-fr.diff: Rebased.
    - debian/patches/hurd-i386/tg-EIEIO-fr.diff: Rebased.
    - debian/patches/hurd-i386/tg-hurdsig-global-dispositions.diff: Rebased.
    - debian/patches/hurd-i386/tg-io_select_timeout.diff: Rebased.
    - debian/patches/kfreebsd/submitted-auxv.diff: Rebased.
  * debian/rules.d/build.mk: Switch to new localedata/install-locale-files:
    - debian/patches/localedata/local-all-no-archive.diff: Dropped for above.
  * debian/testsuite-xfail-debian.mk: XFAIL tst-thread-exit-clobber, and
    tst-minsigstksz*, and tst-xsigstack on armhf, which fail on aarch64 hosts.

  [ Samuel Thibault ]
  * debian/patches/hurd-i386/submitted-net.diff: Rebased.
  * debian/patches/hurd-i386/tg-bits_atomic.h_multiple_threads.diff: Rebased.
  * debian/patches/hurd-i386/local-fix-nss.diff: Fix tst-nss-test3 test.
  * debian/testsuite-xfail-debian.mk: Clean out test build failures, they are
    now handled upstream. Clean out now-fixed tests.

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fix build on alpha with recent kernel headers.  Closes: #934823.
    - debian/patches/any/git-libio-stdout-putc.diff: rebased.
  * debian/control.in/main, debian/rules: drop the multiarch-support package.
    Closes: #910669.
  * debian/glibc-source.filelist, debian/libc6.symbols.powerpcspe,
    debian/rules.d/control.mk, debian/sysdeps/powerpcspe.mk,
    debian/testsuite-xfail-debian.mk: Drop the powerpcspe architecture, it is
    not supported anymore by GCC 9 and will be removed in GLIBC 2.30.
  * debian/rules: do not export SHELL, it is already set through configparms.
  * debian/patches/git-pexpect-pretty-printers.diff: backport pretty printer
    fix to support recent versions of GDB with color output.


=== debian/control ===
--- 
+++ 
@@ -10,10 +10,10 @@
  hurd-dev (>= 1:0.9.git20181030-1) [hurd-i386] <!stage1> | libihash-dev [hurd-i386] <!stage1>,
  kfreebsd-kernel-headers [kfreebsd-any],
  binutils (>= 2.29),
- g++-8, g++-8-multilib [amd64 i386 kfreebsd-amd64 mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el powerpc ppc64 s390x sparc sparc64 x32] <!nobiarch>,
+ g++-9, g++-9-multilib [amd64 i386 kfreebsd-amd64 mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el powerpc ppc64 s390x sparc sparc64 x32] <!nobiarch>,
  python3:native <!nocheck>,
  libidn2-0 (>= 2.0.5~) <!nocheck>,
- libc-bin (>= 2.28.15) <cross>
+ libc-bin (>= 2.29) <cross>
 Build-Depends-Indep: perl, po-debconf (>= 1.0)
 Maintainer: GNU Libc Maintainers <debian-glibc@lists.debian.org>
 Uploaders: Clint Adams <clint@debian.org>, Aurelien Jarno <aurel32@debian.org>, Adam Conrad <adconrad@0c3.net>, Samuel Thibault <sthibault@debian.org>
@@ -99,7 +99,7 @@
 Architecture: all
 Section: localization
 Priority: standard
-Depends: libc-bin (>> 2.28.15), libc-l10n (>> 2.28.15), ${misc:Depends}, debconf | debconf-2.0
+Depends: libc-bin (>> 2.29), libc-l10n (>> 2.29), ${misc:Depends}, debconf | debconf-2.0
 Replaces: manpages-fr-extra (<< 20141022)
 Build-Profiles: <!stage1>
 Description: GNU C Library: National Language (locale) data [support]
@@ -117,7 +117,7 @@
 Section: localization
 Priority: optional
 Multi-Arch: foreign
-Depends: libc-l10n (>> 2.28.15), ${misc:Depends}
+Depends: libc-l10n (>> 2.29), ${misc:Depends}
 Breaks: locales (<< 2.13-17)
 Build-Profiles: <!stage1>
 Description: GNU C Library: Precompiled locale data
@@ -139,27 +139,8 @@
  query. You should install this package only if you use
  slow services like LDAP, NIS or NIS+.
 
-Package: multiarch-support
-Architecture: any
-Section: oldlibs
-Multi-Arch: foreign
-Depends: ${misc:Depends},
-         libc6 (>= 2.3.6-2) [!any-i386 !alpha !armhf !hurd-any !ia64 !kfreebsd-any],
-         libc6.1 (>= 2.3.6-2) [alpha ia64],
-         libc0.3 (>= 2.3.6-2) [!linux-any !kfreebsd-any !hurd-i386],
-         libc0.1 (>= 2.3.6-2) [!linux-any !hurd-any !kfreebsd-i386],
-         libc6 (>= 2.13-5) [armhf i386],
-         libc0.3 (>= 2.13-5) [hurd-i386],
-         libc0.1 (>= 2.13-5) [kfreebsd-i386],
-Priority: optional
-Build-Profiles: <!stage1>
-Description: Transitional package to ensure multiarch compatibility
- This is a transitional package used to ensure multiarch support is present
- in ld.so before unpacking libraries to the multiarch directories.  It can
- be removed once nothing on the system depends on it.
-
 Package: libc6
-Architecture: amd64 arm64 armel armhf hppa i386 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el nios2 powerpc powerpcspe ppc64 ppc64el riscv64 sparc sparc64 s390x sh3 sh4 x32 loongarch64
+Architecture: amd64 arm64 armel armhf hppa i386 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el nios2 powerpc ppc64 ppc64el riscv64 sparc sparc64 s390x sh3 sh4 x32
 Section: libs
 Priority: optional
 Multi-Arch: same
@@ -168,7 +149,7 @@
 Suggests: glibc-doc, debconf | debconf-2.0, libc-l10n, locales [!hurd-i386]
 Provides: libc6-sparcv9b [sparc sparc64], libc0.1-i686 [kfreebsd-i386], libc0.3-i686 [hurd-i386], libc6-i686 [i386]
 Conflicts: libc6-loongson2f [mipsel], libc0.1-i686 [kfreebsd-i386], libc6-i686 [i386], openrc (<< 0.27-2~)
-Breaks: nscd (<< 2.28.15), locales (<< 2.28.15), locales-all (<< 2.28.15), hurd (<< 1:0.5.git20140203-1), libtirpc1 (<< 0.2.3), r-cran-later (<< 0.7.5+dfsg-2), nocache (<< 1.1-1~)
+Breaks: nscd (<< 2.29), locales (<< 2.29), locales-all (<< 2.29), hurd (<< 1:0.9.git20170910-1), libtirpc1 (<< 0.2.3), r-cran-later (<< 0.7.5+dfsg-2), nocache (<< 1.1-1~), iraf-fitsutil (<< 2018.07.06-4)
 Replaces: libc6-amd64 [amd64],
           libc6-i386 [i386],
           libc0.1-i686 [kfreebsd-i386],
@@ -191,7 +172,7 @@
  and the standard math library, as well as many others.
 
 Package: libc6-dev
-Architecture: amd64 arm64 armel armhf hppa i386 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el nios2 powerpc powerpcspe ppc64 ppc64el riscv64 sparc sparc64 s390x sh3 sh4 x32 loongarch64
+Architecture: amd64 arm64 armel armhf hppa i386 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el nios2 powerpc ppc64 ppc64el riscv64 sparc sparc64 s390x sh3 sh4 x32
 Section: libdevel
 Priority: optional
 Multi-Arch: same
@@ -206,7 +187,7 @@
  and link programs which use the standard C library.
 
 Package: libc6-dbg
-Architecture: amd64 arm64 armel armhf hppa i386 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el nios2 powerpc powerpcspe ppc64 ppc64el riscv64 sparc sparc64 s390x sh3 sh4 x32 loongarch64
+Architecture: amd64 arm64 armel armhf hppa i386 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el nios2 powerpc ppc64 ppc64el riscv64 sparc sparc64 s390x sh3 sh4 x32
 Section: debug
 Priority: optional
 Multi-Arch: same
@@ -218,7 +199,7 @@
  library.
 
 Package: libc6-pic
-Architecture: amd64 arm64 armel armhf hppa i386 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el nios2 powerpc powerpcspe ppc64 ppc64el riscv64 sparc sparc64 s390x sh3 sh4 x32 loongarch64
+Architecture: amd64 arm64 armel armhf hppa i386 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el nios2 powerpc ppc64 ppc64el riscv64 sparc sparc64 s390x sh3 sh4 x32
 Section: libdevel
 Priority: optional
 Multi-Arch: same
@@ -234,7 +215,7 @@
 
 Package: libc6-udeb
 Package-Type: udeb
-Architecture: amd64 arm64 armel armhf hppa i386 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el nios2 powerpc powerpcspe ppc64 ppc64el riscv64 sparc sparc64 s390x sh3 sh4 x32 loongarch64
+Architecture: amd64 arm64 armel armhf hppa i386 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el nios2 powerpc ppc64 ppc64el riscv64 sparc sparc64 s390x sh3 sh4 x32
 Section: debian-installer
 Priority: optional
 Provides: libc6, libc-udeb, libnss-dns-udeb, libnss-files-udeb, ${locale-compat:Depends}
@@ -256,3 +237,23 @@
 Recommends: libidn2-0 (>= 2.0.5~)
 Suggests: glibc-doc, debconf | debconf-2.0, libc-l10n, locales [!hurd-i386]
 Provides: libc6-sparcv9b [sparc sparc64], libc0.1-i686 [kfreebsd-i386], libc0.3-i686 [hurd-i386], libc6-i686 [i386]
+Conflicts: libc6-loongson2f [mipsel], libc0.1-i686 [kfreebsd-i386], libc6-i686 [i386], openrc (<< 0.27-2~)
+Breaks: nscd (<< 2.29), locales (<< 2.29), locales-all (<< 2.29), hurd (<< 1:0.9.git20170910-1), libtirpc1 (<< 0.2.3), r-cran-later (<< 0.7.5+dfsg-2), nocache (<< 1.1-1~), iraf-fitsutil (<< 2018.07.06-4)
+Replaces: libc6-amd64 [amd64],
+          libc6-i386 [i386],
+          libc0.1-i686 [kfreebsd-i386],
+          libc0.3-i686 [hurd-i386],
+          libc6-i686 [i386],
+          libc6-x32 [x32],
+          libc0.1-i386 [kfreebsd-i386],
+          libc6-powerpc [powerpc],
+          libc6-ppc64 [ppc64],
+          libc6-s390x [s390x],
+          libc6-sparc64 [sparc64],
+          libc6-mips64 [mips64 mips64el],
+          libc6-mipsn32 [mipsn32 mipsn32el],
+          libc6-mips32 [mips mipsel],
+          hurd (<< 20120408-3) [hurd-i386]
+Build-Profiles: <!stage1>
+Description: GNU C Library: Shared libraries
+ Contains the standard libraries that are used by nearly all programs on

=== debian/rules ===
--- 
+++ 
@@ -33,9 +33,6 @@
 DUMMY := $(shell mkdir -p $(stamp))
 
 # Beyond here you shouldn't need to customise anything:
-export SHELL          = /bin/bash -e
-DEB_BUILD_OPTIONS+=nocheck
-
 DEB_HOST_ARCH         ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
 DEB_HOST_ARCH_ENDIAN  ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_ENDIAN)
 DEB_HOST_ARCH_OS      ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
@@ -97,14 +94,14 @@
 BASE_CC = gcc
 BASE_CXX = g++
 BASE_MIG = mig
-DEB_GCC_VERSION ?= -8
-
-RUN_TESTSUITE = yes
+DEB_GCC_VERSION ?= -9
+
+RUN_TESTSUITE = no
 TIMEOUTFACTOR = 25
 
 # Set cross and native compiler names, including version.
-CC     = $(DEB_HOST_GNU_TYPE)-$(BASE_CC)$(DEB_GCC_VERSION) -no-pie -fno-PIE
-CXX    = $(DEB_HOST_GNU_TYPE)-$(BASE_CXX)$(DEB_GCC_VERSION) -no-pie -fno-PIE
+CC     = $(DEB_HOST_GNU_TYPE)-$(BASE_CC)$(DEB_GCC_VERSION)
+CXX    = $(DEB_HOST_GNU_TYPE)-$(BASE_CXX)$(DEB_GCC_VERSION)
 MIG    = $(DEB_HOST_GNU_TYPE)-$(BASE_MIG)
 BUILD_CC = $(DEB_BUILD_GNU_TYPE)-$(BASE_CC)
 BUILD_CXX = $(DEB_BUILD_GNU_TYPE)-$(BASE_CXX)
@@ -137,9 +134,13 @@
     DEB_BUILD_OPTIONS+=nocheck
   endif
 else
-  DEB_ARCH_REGULAR_PACKAGES = $(libc) $(libc)-dev $(libc)-dbg $(libc)-pic libc-bin libc-dev-bin multiarch-support
+  DEB_ARCH_REGULAR_PACKAGES = $(libc) $(libc)-dev $(libc)-dbg $(libc)-pic libc-bin libc-dev-bin
   DEB_INDEP_REGULAR_PACKAGES = glibc-doc glibc-source libc-l10n locales
-  DEB_UDEB_PACKAGES = $(libc)-udeb
+  ifneq ($(filter noudeb,$(DEB_BUILD_PROFILES)),)
+    DEB_UDEB_PACKAGES =
+  else
+    DEB_UDEB_PACKAGES = $(libc)-udeb
+  endif
   ## Locales can only be pre-generated during native compiles
   ifeq ($(DEB_HOST_ARCH),$(DEB_BUILD_ARCH))
     DEB_ARCH_REGULAR_PACKAGES += locales-all
@@ -175,12 +176,10 @@
 DEBUG_libc6-xen = 1
 DEBUG_libc6.1-alphaev67 = 1
 
-ifneq ($(DEB_HOST_ARCH),loongarch64)
 ifeq ($(filter stage1,$(DEB_BUILD_PROFILES)),)
   ifeq ($(threads),yes)
   DEB_ARCH_REGULAR_PACKAGES += nscd
   endif
-endif
 endif
 
 # And now the rules...
